> For the complete documentation index, see [llms.txt](https://docs.robbie.run/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.robbie.run/robbie-concepts/job-configuration-file.md).

# Job Configuration File

Job-specific configuration parameters are stored in the `job_config.yaml` file in your workspace directory. The Robbie Python SDK, by default, reads the `job_conf.yaml` file in the current working directory to determine the funding\_group\_id, environment\_id, and image in the following cases:

* `robbie run` (without –i option)
* `robbie run [commands]` - if the `job_config.yaml` file contains commands, the \[commands] will be used instead.
* Notebook Runner
* Remote Function runs

You can use the `robbie config` command or the `robbie run` command with the –i option to generate and write a `job_config.yaml` file. You can choose any name as long as it ends with .yaml. To use job configuration files with alternate names, pass the `--f` option with the filename to the `robbie run` command or when calling a remote function.

Here’s an example `job_config.yaml` file:

```
version: 1.1
python_job:
  job_type: BASH_COMMAND_RUNNER
  mode: generic
  funding_group_id: cecfc347-5680-4fb0-ae99-b029941b08dd
  environment_id: 52dbdaa5-eb8e-4a3d-9745-77db52b91b34
  image: auto-select
  include_local_dir: true
```

The parameters are defined as follows:

* **job\_type:**  This is the type of job, either:
  * `BASH_COMMAND_RUNNER` for jobs launched from the command line
  * `REMOTE_FUNCTION_CALL` for Python remote functions.
* **mode:** This is Python mode of operation.
  * BASH\_COMMAND\_RUNNER - Can be one of:
    * `generic`- For launching generic, non-python related jobs on the remote machine.
    * `python`-For launching non-conda Python jobs on the remote machine.
    * `conda`- For launching jobs in a mamba/conda environment on the remote machine.
  * REMOTE\_FUNCTION\_CALL
    * `python`-For launching non-conda Python remote functions on the remote machine.
    * `conda`- For launching remote functions in a mamba/conda environment on the remote machine.
* **funding\_group\_id** - String that contains the UUID of the funding group that the job will be billed against. For example, “cecfc347-5680-4fb0-ae99-b000941b08dd”
* **environment\_id** - String that contains the UUID of the environment that the job will use. For example, “d26d6431-f1a5-4cea-b929-a4ed1f70eaaa”
* **image** - String that contains the image name or “auto-select”. By specifying “auto-select” Robbie will choose the correct image for you.
* **customer\_file\_filter** - A list of glob-style patterns to exclude. See <https://www.malikbrowne.com/blog/a-beginners-guide-glob-patterns/>
* **commands** – These are the Linux shell commands to be run.
* **env** – Environment variables and values (in key: value format) to be transferred to the remote machine and made available in the remote environment. If a value is not specified (key: ), the local environment variable will be read and sent to the remote machine.

Before you run starts, you can view these parameters in the Run configuration banner:


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.robbie.run/robbie-concepts/job-configuration-file.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
